__noinference__{
#ifndef _NETDB_H_
#define _NETDB_H_
#ifndef _servent_def_
#define _servent_def_
struct servent{
  char * s_name;
  char *@zeroterm * s_aliases;
  short s_port;
  char * s_proto;
};
#endif
#ifndef _protoent_def_
#define _protoent_def_
struct protoent{
  char * p_name;
  char *@zeroterm * p_aliases;
  short p_proto;
};
#endif
#ifndef NO_RECOVERY
#define NO_RECOVERY 3
#endif
#ifndef HOST_NOT_FOUND
#define HOST_NOT_FOUND 1
#endif
#ifndef NO_DATA
#define NO_DATA 4
#endif
#ifndef TRY_AGAIN
#define TRY_AGAIN 2
#endif

  /* Not defined in OS X or cygwin so we guess :-( */
  #ifndef _in_port_t_def_
  #define _in_port_t_def_
  typedef unsigned short in_port_t;
  #endif

  // FIX:  Need to put in by hand so that we can translate
  // to struct in_addr, rather than the prescribed char *.
  // We thus bake in the fact that addresses are 4 bytes long; 
  // i.e. that the length is assumed to be 4.  If this is not
  // the case, then we are in trouble.
  struct hostent {
    char *h_name;
    char ** @zeroterm h_aliases;
#if defined(__CYGWIN32__) || defined(__CYGWIN__)
      short h_addrtype;
      short h_length; // always 4
#else
      int h_addrtype;
      int h_length;   // always 4
#endif
    struct in_addr **h_addr_list;
#define h_addr h_addr_list[0]
  };

  // FIX: might this be unsafe?  In particular, we might either end up
  //   with a memory leak, since this was probably malloced, or
  //   with some clobbered memory if it's using a static buffer.
  // FIX: should strings be non-NULL?
  extern "C" struct servent *getservbyname(const char * name, const char * proto);

  // FIX: see getservbyname comment
  extern "C" struct hostent *gethostbyname(const char * name);

  // FIX: see getservbyname comment
  extern "C" struct protoent * getprotobyname(const char * name);

  // FIX: should string be non-NULL
  extern "C" void herror(const char *);
#endif
}
