__noinference__{
#ifndef _SYS_SOCKET_H_
#define _SYS_SOCKET_H_
#ifndef __ssize_t_def_
#define __ssize_t_def_
typedef int _ssize_t;
#endif
#ifndef _time_t_def_
#define _time_t_def_
typedef long time_t;
#endif
#ifndef _ssize_t_def_
#define _ssize_t_def_
typedef _ssize_t ssize_t;
#endif
#ifndef _suseconds_t_def_
#define _suseconds_t_def_
typedef long suseconds_t;
#endif
#ifndef _uint16_t_def_
#define _uint16_t_def_
typedef unsigned short uint16_t;
#endif
#ifndef _socklen_t_def_
#define _socklen_t_def_
typedef int socklen_t;
#endif
#ifndef _sa_family_t_def_
#define _sa_family_t_def_
typedef uint16_t sa_family_t;
#endif
#ifndef _sockaddr_def_
#define _sockaddr_def_
struct sockaddr{
  sa_family_t sa_family;
  char sa_data[14U];
};
#endif
#ifndef _linger_def_
#define _linger_def_
struct linger{
  unsigned short l_onoff;
  unsigned short l_linger;
};
#endif
#ifndef _cmsghdr_def_
#define _cmsghdr_def_
struct cmsghdr{
  socklen_t cmsg_len;
  int cmsg_level;
  int cmsg_type;
};
#endif
#ifndef _timeval_def_
#define _timeval_def_
struct timeval{
  time_t tv_sec;
  suseconds_t tv_usec;
};
#endif
#ifndef SOCK_RAW
#define SOCK_RAW 3
#endif
#ifndef MSG_PEEK
#define MSG_PEEK 0x2
#endif
#ifndef SO_REUSEADDR
#define SO_REUSEADDR 0x0004
#endif
#ifndef SOCK_SEQPACKET
#define SOCK_SEQPACKET 5
#endif
#ifndef SO_LINGER
#define SO_LINGER 0x0080
#endif
#ifndef SO_BROADCAST
#define SO_BROADCAST 0x0020
#endif
#ifndef SO_ACCEPTCONN
#define SO_ACCEPTCONN 0x0002
#endif
#ifndef SO_TYPE
#define SO_TYPE 0x1008
#endif
#ifndef SCM_RIGHTS
#define SCM_RIGHTS 0x01
#endif
#ifndef SHUT_RDWR
#define SHUT_RDWR 2
#endif
#ifndef MSG_CTRUNC
#define MSG_CTRUNC 0x0200
#endif
#ifndef AF_UNSPEC
#define AF_UNSPEC 0
#endif
#ifndef MSG_DONTROUTE
#define MSG_DONTROUTE 0x4
#endif
#ifndef SO_DONTROUTE
#define SO_DONTROUTE 0x0010
#endif
#ifndef SOL_SOCKET
#define SOL_SOCKET 0xffff
#endif
#ifndef SO_RCVLOWAT
#define SO_RCVLOWAT 0x1004
#endif
#ifndef SO_SNDTIMEO
#define SO_SNDTIMEO 0x1005
#endif
#ifndef SOCK_DGRAM
#define SOCK_DGRAM 2
#endif
#ifndef SO_OOBINLINE
#define SO_OOBINLINE 0x0100
#endif
#ifndef SO_KEEPALIVE
#define SO_KEEPALIVE 0x0008
#endif
#ifndef CMSG_DATA
#define CMSG_DATA(cmsg) ((unsigned char *) ((struct cmsghdr *)(cmsg) + 1))
#endif
#ifndef AF_INET
#define AF_INET 2
#endif
#ifndef socklen_t
#define socklen_t socklen_t
#endif
#ifndef MSG_TRUNC
#define MSG_TRUNC 0x0100
#endif
#ifndef MSG_OOB
#define MSG_OOB 0x1
#endif
#ifndef SO_SNDBUF
#define SO_SNDBUF 0x1001
#endif
#ifndef SO_DEBUG
#define SO_DEBUG 0x0001
#endif
#ifndef SO_RCVBUF
#define SO_RCVBUF 0x1002
#endif
#ifndef SOCK_STREAM
#define SOCK_STREAM 1
#endif
#ifndef AF_UNIX
#define AF_UNIX 1
#endif
#ifndef SO_SNDLOWAT
#define SO_SNDLOWAT 0x1003
#endif
#ifndef SO_ERROR
#define SO_ERROR 0x1007
#endif
#ifndef SOMAXCONN
#define SOMAXCONN 0x7fffffff
#endif
#ifndef SHUT_RD
#define SHUT_RD 0
#endif
#ifndef SHUT_WR
#define SHUT_WR 1
#endif
#ifndef SO_RCVTIMEO
#define SO_RCVTIMEO 0x1006
#endif

  /* JGM: mini_httpd needs sockaddr, so I've added it back in:
       We omit struct sockaddr because we don't use it in Cyclone */
  /* We omit struct sockaddr_storage because we don't use it in Cyclone */
  /* We omit struct msghdr because it contains a void * field */
  /* We omit CMSG_NXTHDR and CMSG_FIRSTHDR because they pull in msghdr */
  /* We omit struct iovec because it contains a void * field */

  /* We omit these because they rely on msghdr */
  /*
    extern ssize_t sendmsg(int fd, const struct msghdr *message, int flags);
    extern ssize_t recvmsg(int fd, struct msghdr *message, int flags);
  */

  /* Many architectures don't define this :-( */
  #ifndef _socklen_t_def_
  #define _socklen_t_def_
  #ifndef socklen_t
  /* Cygwin #defines socklen_t */
  typedef int socklen_t;
  #endif
  #endif
  /* Not defined in OS X */
  #ifndef _sa_family_t_def_
  #define _sa_family_t_def_
  typedef unsigned char sa_family_t;
  #endif

  extern datatype SockAddr<`r::E> {
    SA_sockaddr_in(struct sockaddr_in @`r);
    /* We will add other cases as necessary, e.g., SockAddr_In6 */

    /* The remaining cases are for the argument following the type-varying
       argument; they could be eliminated if we had per-arg injection. */
    /* NOTE: ORDER MATTERS! on these inject things */
    SA_socklenptr(socklen_t @`r); // accept, getpeername, getsockname, recvfrom
    SA_socklen(socklen_t); // bind, connect, sendto
  };
  typedef datatype SockAddr<`r> @`r SA<`r>;

  extern datatype SockOpt<`r::E> {
    SO_int(int @`r);
    SO_timeval(struct timeval @`r);
    SO_linger(struct linger@`r);
    /* The remaining cases are for the argument following the type-varying
       argument; they could be eliminated if we had per-arg injection. */
    SO_socklenptr(socklen_t @`r); // getsockopt
    SO_socklen(socklen_t);        // setsockopt
  };
  typedef datatype SockOpt<`r> @`r SO<`r>;

  extern int accept(int fd, ... inject SA);

  datatype exn { extern SocketError };

  extern int bind(int fd, ... inject SA);

  extern int connect(int fd, ... inject SA);

  extern int getpeername(int fd, ... inject SA);

  extern int getsockname(int fd, ... inject SA);

  extern int getsockopt(int fd, int level, int optname, ... inject SO);

  extern "C" int listen(int fd, int n);

  extern ssize_t recv(int fd, char ? @nozeroterm buf, size_t n, int flags);

  extern ssize_t recvfrom(int fd, char ? @nozeroterm buf, size_t n, int flags,
                          ... inject SA);

  extern ssize_t send(int fd, const char ? @nozeroterm buf, size_t n, int flags);

  extern ssize_t sendto(int fd, const char ? @nozeroterm buf, size_t n, int flags,
                        ... inject SA);

  extern int setsockopt(int fd, int level, int optname, ... inject SO);

  extern "C" int shutdown(int fd, int how);

  extern "C" int socket(int domain, int type, int protocol);

  extern "C" int socketpair(int domain, int type, int protocol, int @{2} fds);
#endif
}
